/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Component.h"

namespace morpheo              {
namespace behavioural          {

#undef  FUNCTION
#define FUNCTION "Component::get_component"

  string Component::get_component (void)
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");

    uint32_t               depth          = 0;
    string                 separator      = "\n";
    bool                   last_separator = false;

    list<Entity *>::iterator  i  = _list_component->begin();
    bool                   empty = _list_component->empty();

    string                 tab   = string(depth,'\t');
    ostringstream          text;

    if (not empty)
      {
	// First
	if (i != _list_component->end())
	  {
	    text << tab << **i;
	    ++i;
	  }
	
	while (i != _list_component->end())
	  {
	    text << separator;
	    text << tab << **i;
	    ++i;
	  }
	
	if (last_separator)
	  text << separator;
      }

    log_printf(FUNC,Behavioural,FUNCTION,"End");

    return text.str();
  };

}; // end namespace behavioural          
}; // end namespace morpheo              
